#include <stdlib.h>
#include <stdio.h>
#include "hexagon.h"

/*  hexdot
    Copyright (C) 2007 C. Alex McLean

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

void push(int *array, int value) {
  while(*array != 0) {
    ++array;
  }
  *array = value;
}

extern t_hexagon hexagon (int size) {
  int lengths[size];
  int x, y, i;
  int **hex;
  int points = 0;
  int point = 0;
  int edges = 0;
  t_hexagon result;

  for (y = 0; y < size; ++y) {
    if (y <= (int) ((size - 1) / 2)) {
      lengths[y] = y + ((size - 1) / 2) + 1;
    }
    else {
      lengths[y] = size - y + ((size - 1) / 2);
    }
    points += lengths[y];
  }
  
  hex = (int **) calloc(points + 1, sizeof(int *));

  for (i = 0; i < points; i++) {
    hex[i] = (int *) calloc(1, sizeof(int) * 3);
  }
  
  for (y = 0; y < size; ++y) {
    int len = lengths[y];
    for (x = 0; x < len; ++x) {
      if (x < (len - 1)) {
	push(hex[point], point+1);
	edges++;
      }
      if (y < (size - 1)) {
	if (y < ((size - 1) / 2)) {
	  push(hex[point], point + len);
	  edges++;
	  push(hex[point], point + len + 1);
	  edges++;
	}
	else {
	  if (x > 0) {
	    push(hex[point], point + len - 1);
	    edges++;
	  }
	  if (x < (len - 1)) {
	    push(hex[point], point + len);
	    edges++;
	  }
	}
      }
      ++point;
    }
  }

#ifdef DEBUG
  for (i = 0; i < points; ++i) {
    printf("%d: ", i);
    for (x = 0; x < 3; ++x) {
      if (hex[i][x] == 0) {
	break;
      }
      printf(" %d ", hex[i][x]);
    }
    printf("\n");
  }
#endif
  result.hex = hex;
  result.edges = edges;
  result.junctions = points;
  return(result);
}

