#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "hexagon.h"

/*  hexdot
    Copyright (C) 2007 C. Alex McLean

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

void dot_hexagon(t_hexagon hexagon) {
  int from;
  int **hex = hexagon.hex;
  int j;

  printf("digraph{\n");
  for (from = 0; from < hexagon.junctions; ++from) {
    printf("  node [label=\"J%d\"] j%d\n", from, from);
  }
  for (from = 0; from < hexagon.junctions; ++from) {
    int *to = hex[from];

    for (j = 0; j < 3; ++j) {
      if (*to == 0) {
	break;
      }
      printf("  j%d -> j%d\n", from, *to);
      to++;
    }
  }
  
  printf("}\n");
}

int main (int argc, char **argv) {
  int size = 13;
  t_hexagon h;
  int **hex;
    
  if (argc > 1) {
    size = atoi(argv[1]);
  }
  h = hexagon(size);

  dot_hexagon(h);

  return 0;
}

